diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/SpecimenCollectionDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/SpecimenCollectionDetailElement.java
index c5ee04ebb..75c131ed0 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/SpecimenCollectionDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/occurrence/SpecimenCollectionDetailElement.java
@@ -12,13 +12,13 @@ package eu.etaxonomy.taxeditor.ui.section.occurrence;
 
 import org.eclipse.swt.events.SelectionListener;
 
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
 import eu.etaxonomy.cdm.model.occurrence.Specimen;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.DerivedUnitBaseSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -32,7 +32,7 @@ import eu.etaxonomy.taxeditor.ui.selection.DerivedUnitBaseSelectionElement;
 public class SpecimenCollectionDetailElement extends
 		AbstractEntityCollectionElement<Specimen> {
 
-	private DerivedUnitBaseSelectionElement selection_derivedUnit;
+	private EntitySelectionElement<DerivedUnitBase> selection_derivedUnit;
 
 	/**
 	 * <p>
@@ -82,10 +82,10 @@ public class SpecimenCollectionDetailElement extends
 	/** {@inheritDoc} */
 	@Override
 	public void createControls(ICdmFormElement element, int style) {
-		selection_derivedUnit = (DerivedUnitBaseSelectionElement) formFactory
-				.createSelectionElement(SelectionType.DERIVED_UNIT,
+		selection_derivedUnit = formFactory
+				.createSelectionElement(DerivedUnitBase.class,
 						getConversationHolder(), element, "Derived Unit", null,
-						DerivedUnitBaseSelectionElement.EDITABLE | DerivedUnitBaseSelectionElement.SELECTABLE, style);
+						EntitySelectionElement.EDITABLE | EntitySelectionElement.SELECTABLE, style);
 	}
 
 	/*
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/NomenclaturalReferenceDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/NomenclaturalReferenceDetailElement.java
index f56d11bd3..977e56d64 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/NomenclaturalReferenceDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/NomenclaturalReferenceDetailElement.java
@@ -10,15 +10,13 @@
 
 package eu.etaxonomy.taxeditor.ui.section.reference;
 
-import org.apache.log4j.Logger;
-
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
+import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.ReferenceSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -32,9 +30,7 @@ import eu.etaxonomy.taxeditor.ui.selection.ReferenceSelectionElement;
 public class NomenclaturalReferenceDetailElement extends
 		AbstractCdmDetailElement<TaxonNameBase> {
 
-	private static final Logger logger = Logger
-			.getLogger(NomenclaturalReferenceDetailElement.class);
-	private ReferenceSelectionElement selection_nomenclaturalReference;
+	private EntitySelectionElement<Reference> selection_nomenclaturalReference;
 	private TextWithLabelElement text_referenceDetail;
 
 	/**
@@ -60,11 +56,11 @@ public class NomenclaturalReferenceDetailElement extends
 	@Override
 	protected void createControls(ICdmFormElement formElement,
 			TaxonNameBase entity, int style) {
-		selection_nomenclaturalReference = (ReferenceSelectionElement) formFactory
-				.createSelectionElement(SelectionType.REFERENCE,
+		selection_nomenclaturalReference = formFactory
+				.createSelectionElement(Reference.class,
 						getConversationHolder(), formElement, "Reference",
-						entity.getNomenclaturalReference(),
-						ReferenceSelectionElement.DEFAULT, style);
+						(Reference) entity.getNomenclaturalReference(),
+						EntitySelectionElement.ALL, style);
 		text_referenceDetail = formFactory.createTextWithLabelElement(
 				formElement, "Reference Detail",
 				entity.getNomenclaturalMicroReference(), style);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/ReferenceDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/ReferenceDetailElement.java
index 40f7c99e5..cf7035e83 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/ReferenceDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/ReferenceDetailElement.java
@@ -17,6 +17,8 @@ import java.util.List;
 
 import org.eclipse.swt.SWT;
 
+import eu.etaxonomy.cdm.model.agent.AgentBase;
+import eu.etaxonomy.cdm.model.agent.Institution;
 import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
@@ -32,11 +34,8 @@ import eu.etaxonomy.taxeditor.ui.element.IExceptionHandler;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
 import eu.etaxonomy.taxeditor.ui.element.TimePeriodElement;
 import eu.etaxonomy.taxeditor.ui.element.UriWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractIdentifiableEntityDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.AgentSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.InstitutionSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.ReferenceSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -64,13 +63,13 @@ public class ReferenceDetailElement extends AbstractIdentifiableEntityDetailElem
 	private TextWithLabelElement text_title;
 	private TextWithLabelElement text_volume;
 	private UriWithLabelElement text_uri;
-	private AgentSelectionElement selection_authorTeam;
+	private EntitySelectionElement<AgentBase> selection_authorTeam;
 	private TimePeriodElement element_timePeriod;
-	private ReferenceSelectionElement selection_inReference;
-	private InstitutionSelectionElement selection_institution;
+	private EntitySelectionElement<Reference> selection_inReference;
+	private EntitySelectionElement<Institution> selection_institution;
 	private EnumComboElement<ReferenceType> combo_referenceType;
 
-	private ReferenceSelectionElement selection_inSeries;
+	private EntitySelectionElement<Reference> selection_inSeries;
 
 	/**
 	 * <p>
@@ -116,11 +115,11 @@ public class ReferenceDetailElement extends AbstractIdentifiableEntityDetailElem
 				"Title", entity.getTitle(), style);
 
 		// author team
-		selection_authorTeam = (AgentSelectionElement) formFactory
-				.createSelectionElement(SelectionType.AGENT,
+		selection_authorTeam = formFactory
+				.createSelectionElement(AgentBase.class,
 						getConversationHolder(), formElement, "Author",
 						AuthorHelper.getAuthor(entity.getAuthorTeam()),
-						AgentSelectionElement.DEFAULT, style);
+						EntitySelectionElement.ALL, style);
 
 		ReferenceType referenceType = entity.getType();
 
@@ -212,11 +211,11 @@ public class ReferenceDetailElement extends AbstractIdentifiableEntityDetailElem
 		}
 
 		if (createInReferenceWidget) {
-			selection_inReference = (ReferenceSelectionElement) formFactory
-					.createSelectionElement(SelectionType.REFERENCE,
+			selection_inReference = formFactory
+					.createSelectionElement(Reference.class,
 							getConversationHolder(), element, label,
 							reference.getInReference(),
-							ReferenceSelectionElement.DEFAULT, style);
+							EntitySelectionElement.ALL, style);
 		}
 	}
 
@@ -275,20 +274,20 @@ public class ReferenceDetailElement extends AbstractIdentifiableEntityDetailElem
 
 		if (referenceType.equals(ReferenceType.Report)) {
 			// institution
-			selection_institution = (InstitutionSelectionElement) formFactory
-					.createSelectionElement(SelectionType.INSTITUTION,
+			selection_institution = formFactory
+					.createSelectionElement(Institution.class,
 							getConversationHolder(), element, "Institution",
 							reference.getInstitution(),
-							InstitutionSelectionElement.DEFAULT, style);
+							EntitySelectionElement.ALL, style);
 		}
 
 		if (referenceType.equals(ReferenceType.Thesis)) {
 			// school
-			selection_institution = (InstitutionSelectionElement) formFactory
-					.createSelectionElement(SelectionType.INSTITUTION,
+			selection_institution = formFactory
+					.createSelectionElement(Institution.class,
 							getConversationHolder(), element, "School",
 							reference.getSchool(),
-							InstitutionSelectionElement.DEFAULT, style);
+							EntitySelectionElement.ALL, style);
 		}
 
 		if (referenceType.equals(ReferenceType.Proceedings)) {
@@ -339,11 +338,11 @@ public class ReferenceDetailElement extends AbstractIdentifiableEntityDetailElem
 	private void createPrintedUnitControls(ICdmFormElement element,
 			ReferenceType referenceType, Reference reference, int style) {
 		// in series
-		selection_inSeries = (ReferenceSelectionElement) formFactory
-				.createSelectionElement(SelectionType.REFERENCE,
+		selection_inSeries = formFactory
+				.createSelectionElement(Reference.class,
 						getConversationHolder(), element, "In Series",
-						reference.getInSeries(),
-						ReferenceSelectionElement.DEFAULT, style);
+						(Reference) reference.getInSeries(),
+						EntitySelectionElement.ALL, style);
 
 		// editor
 		text_editor = formFactory.createTextWithLabelElement(element, "Editor",
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/ReferenceWizardPage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/ReferenceWizardPage.java
index 310ac175f..bfd30b9e7 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/ReferenceWizardPage.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/reference/ReferenceWizardPage.java
@@ -16,10 +16,10 @@ import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.taxeditor.ui.element.AbstractCdmEntityWizardPage;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
+import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
 import eu.etaxonomy.taxeditor.ui.element.CdmPropertyChangeEvent;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.IExceptionHandler;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
 
 /**
@@ -48,7 +48,7 @@ public class ReferenceWizardPage extends AbstractCdmEntityWizardPage<Reference>
 	 * @see eu.etaxonomy.taxeditor.forms.CdmEntityWizardPage#createElement(eu.etaxonomy.taxeditor.forms.ICdmFormElement)
 	 */
 	/** {@inheritDoc} */
-	public AbstractCdmDetailElement createElement(ICdmFormElement rootElement){
+	public AbstractCdmDetailElement<Reference> createElement(ICdmFormElement rootElement){
 		ReferenceDetailElement referenceElement = (ReferenceDetailElement) formFactory.createCdmDetailElement(DetailType.REFERENCEBASE, rootElement, SWT.NULL);
 		referenceElement.addExceptionHandler(this);
 		referenceElement.setEntity(entity);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/AbstractOriginalSourceElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/AbstractOriginalSourceElement.java
index 82114879b..e004ba3f3 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/AbstractOriginalSourceElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/AbstractOriginalSourceElement.java
@@ -10,7 +10,6 @@
 
 package eu.etaxonomy.taxeditor.ui.section.supplemental;
 
-import org.apache.log4j.Logger;
 import org.eclipse.swt.events.SelectionListener;
 
 import eu.etaxonomy.cdm.model.common.OriginalSourceBase;
@@ -27,8 +26,6 @@ import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
  * @version 1.0
  */
 public abstract class AbstractOriginalSourceElement<T extends OriginalSourceBase> extends AbstractReferencedEntityElement<T> {
-	private static final Logger logger = Logger
-			.getLogger(AbstractOriginalSourceElement.class);
 	protected TextWithLabelElement text_idInSource;
 	protected TextWithLabelElement text_idNamespace;
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/AbstractReferencedEntityElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/AbstractReferencedEntityElement.java
index 1d3cb6d4e..c77b5379e 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/AbstractReferencedEntityElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/AbstractReferencedEntityElement.java
@@ -14,13 +14,13 @@ import org.eclipse.swt.SWT;
 import org.eclipse.swt.events.SelectionListener;
 
 import eu.etaxonomy.cdm.model.common.ReferencedEntityBase;
+import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.ReferenceSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -34,7 +34,7 @@ import eu.etaxonomy.taxeditor.ui.selection.ReferenceSelectionElement;
 public abstract class AbstractReferencedEntityElement<T extends ReferencedEntityBase>
 		extends AbstractEntityCollectionElement<T> {
 
-	protected ReferenceSelectionElement selection_reference;
+	protected EntitySelectionElement<Reference> selection_reference;
 	protected TextWithLabelElement text_referenceDetail;
 
 	protected TextWithLabelElement text_originaleNameString;
@@ -77,10 +77,10 @@ public abstract class AbstractReferencedEntityElement<T extends ReferencedEntity
 	/** {@inheritDoc} */
 	@Override
 	public void createControls(ICdmFormElement formElement, int style) {
-		selection_reference = (ReferenceSelectionElement) formFactory
-				.createSelectionElement(SelectionType.REFERENCE,
+		selection_reference = formFactory
+				.createSelectionElement(Reference.class,
 						getConversationHolder(), formElement, "Reference",
-						null, ReferenceSelectionElement.DEFAULT, style);
+						null, EntitySelectionElement.ALL, style);
 		text_referenceDetail = formFactory.createTextWithLabelElement(
 				formElement, "Reference Detail", null, SWT.NULL);
 		if (hasOriginalNameString)
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/CreditElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/CreditElement.java
index 2837330a4..28ad8a039 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/CreditElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/CreditElement.java
@@ -5,14 +5,14 @@ package eu.etaxonomy.taxeditor.ui.section.supplemental;
 
 import org.eclipse.swt.events.SelectionListener;
 
+import eu.etaxonomy.cdm.model.agent.AgentBase;
 import eu.etaxonomy.cdm.model.common.Credit;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.AgentSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -25,7 +25,7 @@ import eu.etaxonomy.taxeditor.ui.selection.AgentSelectionElement;
  */
 public class CreditElement extends AbstractEntityCollectionElement<Credit> {
 
-	private AgentSelectionElement agentSelection;
+	private EntitySelectionElement<AgentBase> agentSelection;
 	private TextWithLabelElement text;
 
 	/**
@@ -62,10 +62,10 @@ public class CreditElement extends AbstractEntityCollectionElement<Credit> {
 	/** {@inheritDoc} */
 	@Override
 	public void createControls(ICdmFormElement element, int style) {
-		agentSelection = (AgentSelectionElement) formFactory
-				.createSelectionElement(SelectionType.AGENT,
+		agentSelection = formFactory
+				.createSelectionElement(AgentBase.class,
 						getConversationHolder(), this, "Agent", null,
-						AgentSelectionElement.DEFAULT, style);
+						EntitySelectionElement.ALL, style);
 		text = formFactory.createMultilineTextWithLabel(this, "Text", 100,
 				style);
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/ExtensionElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/ExtensionElement.java
index c972967f5..184aa6f75 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/ExtensionElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/ExtensionElement.java
@@ -12,6 +12,7 @@ import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
 
@@ -49,7 +50,7 @@ public class ExtensionElement extends AbstractEntityCollectionElement<Extension>
 	public void createControls(ICdmFormElement element, int style) {
 		combo_extensionType = formFactory.createTermComboElement(ExtensionType.class, this, null, null, style);
 		text_extensionValue = formFactory.createTextWithLabelElement(element, null, null, style);
-		text_extensionValue.getLayoutComposite().setLayoutData(CdmFormFactory.FILL_HORIZONTALLY());
+		text_extensionValue.getLayoutComposite().setLayoutData(LayoutConstants.FILL_HORIZONTALLY());
 	}
 
 	/* (non-Javadoc)
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/RightsElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/RightsElement.java
index 54d0a65ec..376afb8ec 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/RightsElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/RightsElement.java
@@ -13,10 +13,8 @@ import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.AbstractSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.AgentSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -29,6 +27,10 @@ import eu.etaxonomy.taxeditor.ui.selection.AgentSelectionElement;
  */
 public class RightsElement extends AbstractEntityCollectionElement<Rights> {
 
+	private TermComboElement<RightsTerm> combo_rightsType;
+	private EntitySelectionElement<AgentBase> selection_agent;
+	private TextWithLabelElement text;
+	
 	/**
 	 * <p>
 	 * Constructor for RightsElement.
@@ -53,9 +55,6 @@ public class RightsElement extends AbstractEntityCollectionElement<Rights> {
 		super(cdmFormFactory, formElement, element, removeListener, null, style);
 	}
 
-	private TermComboElement<RightsTerm> combo_rightsType;
-	private AbstractSelectionElement<AgentBase> selection_agent;
-	private TextWithLabelElement text;
 
 	/*
 	 * (non-Javadoc)
@@ -70,8 +69,8 @@ public class RightsElement extends AbstractEntityCollectionElement<Rights> {
 		combo_rightsType = formFactory.createTermComboElement(
 				RightsTerm.class, this, "Rights Type", null, style);
 		selection_agent = formFactory.createSelectionElement(
-				SelectionType.AGENT, getConversationHolder(), this, "Agent",
-				null, AgentSelectionElement.DEFAULT, style);
+				AgentBase.class, getConversationHolder(), this, "Agent",
+				null, EntitySelectionElement.ALL, style);
 		text = formFactory.createMultilineTextWithLabel(this, "Text", 100,
 				style);
 	}
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/VersionElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/VersionElement.java
index ce39b3b8f..353a1dae3 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/VersionElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/supplemental/VersionElement.java
@@ -21,6 +21,7 @@ import eu.etaxonomy.taxeditor.ui.element.AbstractCdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.IEntityElement;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
 
 /**
@@ -50,10 +51,10 @@ public class VersionElement extends AbstractCdmFormElement implements IEntityEle
 		super(formFactory, parentElement);
 			
 		label_created = formFactory.createLabel(getLayoutComposite(), null, style);
-		label_created.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY());
+		label_created.setLayoutData(LayoutConstants.FILL_HORIZONTALLY());
 
 		label_updated = formFactory.createLabel(getLayoutComposite(), null, style);
-		label_updated.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY());
+		label_updated.setLayoutData(LayoutConstants.FILL_HORIZONTALLY());
 		
 		
 		setEntity(entity);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonBaseDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonBaseDetailElement.java
index f32b84e2b..ad76f3bf5 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonBaseDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonBaseDetailElement.java
@@ -15,15 +15,15 @@ import java.util.Arrays;
 import org.eclipse.jface.util.PropertyChangeEvent;
 import org.eclipse.swt.SWT;
 
+import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.CheckboxElement;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractIdentifiableEntityDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.ReferenceSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -40,7 +40,7 @@ public class TaxonBaseDetailElement extends AbstractIdentifiableEntityDetailElem
 
 	private CheckboxElement checkbox_useNameCache;
 
-	private ReferenceSelectionElement selection_secundum;
+	private EntitySelectionElement<Reference> selection_secundum;
 
 	private TextWithLabelElement text_appendedPhrase;
 
@@ -75,10 +75,10 @@ public class TaxonBaseDetailElement extends AbstractIdentifiableEntityDetailElem
 				"Title Cache", entity.getTitleCache(),
 				entity.isProtectedTitleCache(), style);
 
-		selection_secundum = (ReferenceSelectionElement) formFactory
-		.createSelectionElement(SelectionType.REFERENCE,
+		selection_secundum = formFactory
+		.createSelectionElement(Reference.class,
 				getConversationHolder(), formElement, "Secundum",
-				entity.getSec(), ReferenceSelectionElement.DEFAULT,
+				entity.getSec(), EntitySelectionElement.ALL,
 				style);
 		
 		text_appendedPhrase = formFactory.createTextWithLabelElement(
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonDetailElement.java
index 9d6b52cdd..b28944f2a 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonDetailElement.java
@@ -16,9 +16,8 @@ import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.TaxonSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * @author n.hoffmann
@@ -27,7 +26,7 @@ import eu.etaxonomy.taxeditor.ui.selection.TaxonSelectionElement;
  */
 public class TaxonDetailElement extends AbstractEntityCollectionElement<Taxon> {
 
-	private TaxonSelectionElement selection_taxon;
+	private EntitySelectionElement<Taxon> selection_taxon;
 
 	/**
 	 * @param formFactory
@@ -63,10 +62,10 @@ public class TaxonDetailElement extends AbstractEntityCollectionElement<Taxon> {
 	 */
 	@Override
 	public void createControls(ICdmFormElement element, int style) {
-		selection_taxon = (TaxonSelectionElement) formFactory
-				.createSelectionElement(SelectionType.TAXON,
+		selection_taxon = formFactory
+				.createSelectionElement(Taxon.class,
 						getConversationHolder(), element, "Taxon", null,
-						TaxonSelectionElement.NOTHING, style);
+						EntitySelectionElement.NOTHING, style);
 	}
 
 	/*
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonRelationshipDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonRelationshipDetailElement.java
index eb559b0e8..7b04da49e 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonRelationshipDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/taxon/TaxonRelationshipDetailElement.java
@@ -19,9 +19,8 @@ import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.CdmPropertyChangeEvent;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.TaxonSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * @author n.hoffmann
@@ -32,7 +31,7 @@ public class TaxonRelationshipDetailElement extends AbstractCdmDetailElement<Tax
 
 	private TermComboElement<TaxonRelationshipTypeInverseContainer> combo_taxonRelationshipType;
 	
-	private TaxonSelectionElement selection_relatedTaxon;
+	private EntitySelectionElement<Taxon> selection_relatedTaxon;
 	
 	public TaxonRelationshipDetailElement(CdmFormFactory formFactory,
 			ICdmFormElement formElement) {
@@ -47,10 +46,10 @@ public class TaxonRelationshipDetailElement extends AbstractCdmDetailElement<Tax
 				formElement, "Relationship Type", 
 				getTaxonRelationshipTypeInverseContainer(), style);
 		combo_taxonRelationshipType.setEnabled(false);
-		selection_relatedTaxon = (TaxonSelectionElement) formFactory.createSelectionElement(
-				SelectionType.TAXON, getConversationHolder(), 
+		selection_relatedTaxon = formFactory.createSelectionElement(
+				Taxon.class, getConversationHolder(), 
 				formElement, "Related Taxon", getRelatedTaxon(), 
-				TaxonSelectionElement.SELECTABLE, style);
+				EntitySelectionElement.SELECTABLE, style);
 	}
 	
 	private Taxon getRelatedTaxon() {
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/user/GroupsByUserDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/user/GroupsByUserDetailElement.java
index 7b29f2f31..061fb8afa 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/user/GroupsByUserDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/user/GroupsByUserDetailElement.java
@@ -6,9 +6,8 @@ import eu.etaxonomy.cdm.model.common.Group;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.GroupSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * 
@@ -19,7 +18,7 @@ import eu.etaxonomy.taxeditor.ui.selection.GroupSelectionElement;
 public class GroupsByUserDetailElement extends
 		AbstractEntityCollectionElement<Group> {
 
-	private GroupSelectionElement selection_group;
+	private EntitySelectionElement<Group> selection_group;
 
 	/**
 	 * @param formFactory
@@ -55,10 +54,10 @@ public class GroupsByUserDetailElement extends
 	 */
 	@Override
 	public void createControls(ICdmFormElement element, int style) {
-		selection_group = (GroupSelectionElement) formFactory
-				.createSelectionElement(SelectionType.GROUP,
+		selection_group = formFactory
+				.createSelectionElement(Group.class,
 						getConversationHolder(), element, "Group", getEntity(),
-						GroupSelectionElement.DEFAULT, style);
+						EntitySelectionElement.NOTHING, style);
 	}
 
 	/*
